=begin
#CityPay Payment API

# This CityPay API is a HTTP RESTful payment API used for direct server to server transactional processing. It provides a number of payment mechanisms including: Internet, MOTO, Continuous Authority transaction processing, 3-D Secure decision handling using RFA Secure, Authorisation, Refunding, Pre-Authorisation, Cancellation/Voids and Completion processing. The API is also capable of tokinsed payments using Card Holder Accounts.  ## Compliance and Security <aside class=\"notice\">   Before we begin a reminder that your application will need to adhere to PCI-DSS standards to operate safely   and to meet requirements set out by Visa and MasterCard and the PCI Security Standards Council including: </aside>  * Data must be collected using TLS version 1.2 using [strong cryptography](#enabled-tls-ciphers). We will not accept calls to our API at   lower grade encryption levels. We regularly scan our TLS endpoints for vulnerabilities and perform TLS assessments   as part of our compliance program. * The application must not store sensitive card holder data (CHD) such as the card security code (CSC) or   primary access number (PAN) * The application must not display the full card number on receipts, it is recommended to mask the PAN   and show the last 4 digits. The API will return this for you for ease of receipt creation * If you are developing a website, you will be required to perform regular scans on the network where you host the   application to meet your compliance obligations * You will be required to be PCI Compliant and the application must adhere to the security standard. Further information   is available from [https://www.pcisecuritystandards.org/](https://www.pcisecuritystandards.org/) * The API verifies that the request is for a valid account and originates from a trusted source using the remote IP   address. Our application firewalls analyse data that may be an attempt to break a large number of security common   security vulnerabilities. 

Contact: support@citypay.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.0.0-SNAPSHOT

=end

# Common files
require 'citypay_api_client/api_client'
require 'citypay_api_client/api_error'
require 'citypay_api_client/version'
require 'citypay_api_client/configuration'

# Models
require 'citypay_api_client/models/account_create'
require 'citypay_api_client/models/account_status'
require 'citypay_api_client/models/acknowledgement'
require 'citypay_api_client/models/airline_advice'
require 'citypay_api_client/models/airline_segment'
require 'citypay_api_client/models/auth_reference'
require "citypay_api_client/models/api_key"
require 'citypay_api_client/models/auth_references'
require 'citypay_api_client/models/auth_request'
require 'citypay_api_client/models/auth_response'
require 'citypay_api_client/models/authen_required'
require 'citypay_api_client/models/c_res_auth_request'
require 'citypay_api_client/models/capture_request'
require 'citypay_api_client/models/card'
require 'citypay_api_client/models/card_holder_account'
require 'citypay_api_client/models/card_status'
require 'citypay_api_client/models/charge_request'
require 'citypay_api_client/models/contact_details'
require 'citypay_api_client/models/decision'
require 'citypay_api_client/models/error'
require 'citypay_api_client/models/external_mpi'
require 'citypay_api_client/models/list_merchants_response'
require 'citypay_api_client/models/mcc6012'
require 'citypay_api_client/models/merchant'
require 'citypay_api_client/models/pa_res_auth_request'
require 'citypay_api_client/models/ping'
require 'citypay_api_client/models/register_card'
require 'citypay_api_client/models/request_challenged'
require 'citypay_api_client/models/retrieve_request'
require 'citypay_api_client/models/three_d_secure'
require 'citypay_api_client/models/void_request'

# APIs
require 'citypay_api_client/api/card_holder_account_api'
require 'citypay_api_client/api/operational_api'
require 'citypay_api_client/api/payment_processing_api'

module CityPayApiClient
  class << self
    # Customize default settings for the SDK using block.
    #   CityPayApiClient.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
